From d9e07f6e89f7eaaaadcc1b01c8b92095ef102b51 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?=E5=A7=9C=E6=B5=B7=E5=A4=A9?= <1076168468@qq.com>
Date: Sat, 29 Oct 2022 15:33:43 +0800
Subject: [PATCH 1/2] =?UTF-8?q?=E4=BB=BB=E5=8A=A1=E5=AE=8C=E6=88=90?=
 =?UTF-8?q?=EF=BC=8C=E6=8F=90=E4=BA=A4=E4=BD=9C=E4=B8=9A?=
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

---
 pfnlist.c |  10 +--
 sysproc.c | 207 ++++++++++++++++++++++++++++++++++++++++++++++--------
 2 files changed, 182 insertions(+), 35 deletions(-)

diff --git a/pfnlist.c b/pfnlist.c
index fa77e0b..3a4ad74 100644
--- a/pfnlist.c
+++ b/pfnlist.c
@@ -145,13 +145,13 @@ MiAllocateAnyPages(
 		//
 		for (i = 0; i < NumberOfPages && MiFreePageCount > 0; i++) {
 
-			Pfn = MiFreePageListHead;
-			MiFreePageListHead = MiGetPfnDatabaseEntry(Pfn)->Next;
-			MiFreePageCount--;
+			Pfn = MiFreePageListHead;	//¼׸ҳ
+			MiFreePageListHead = MiGetPfnDatabaseEntry(Pfn)->Next;	//ҳȡ
+			MiFreePageCount--;	//ٿҳ¼
 
-			MiGetPfnDatabaseEntry(Pfn)->PageState = BUSY_PAGE;
+			MiGetPfnDatabaseEntry(Pfn)->PageState = BUSY_PAGE;	//ҳΪBUSY_PAGE
 
-			PfnArray[i] = Pfn;
+			PfnArray[i] = Pfn;	//¼صĿҳҳ
 		}
 
 		//
diff --git a/sysproc.c b/sysproc.c
index ba79659..957b1bf 100644
--- a/sysproc.c
+++ b/sysproc.c
@@ -953,25 +953,20 @@ ConsoleCmdResumeThread(
 // ǺͿ̨ vm صĴ롣
 //
 
+/*
+ṩʾΪ˲һ߽һԣ
+ȫıʵ˲ӦӦóվʹøʾ롣
+ڳʾԤ;ʹɵżȻ̷ʧ
+ӢʱƼ޹˾еκΡ
+*/
+
+
 PRIVATE
 VOID
 ConsoleCmdVM(
 	IN HANDLE StdHandle,
 	IN PCSTR Arg
 	)
-/*++
-
-
-	ͳɽ ID ָĽ̵ַϢ̨vm processid
-
-
-	StdHandle -- ׼롢
-	Arg -- ̵ַ ID
-
-ֵ
-	ޡ
-
---*/
 {
 	BOOL IntState;
 	ULONG ProcID;
@@ -982,6 +977,8 @@ ConsoleCmdVM(
 	ULONG Index, TotalVpnCount, AllocatedVpnCount, FreeVpnCount, VpnCount;
 	STATUS Status;
 	
+	const char* OutputFormat = NULL;
+	
 	//
 	// ַлý ID
 	//
@@ -1010,7 +1007,8 @@ ConsoleCmdVM(
 	//
 	//  VAD м¼ʼҳţҳ
 	//
-	fprintf(StdHandle, "Total Vpn from %d to %d. (0x%X - 0x%X)\n\n",
+	OutputFormat = "Total Vpn from %d to %d. (0x%X - 0x%X)\n\n";
+	fprintf(StdHandle, OutputFormat,
 		pVadList->StartingVpn, pVadList->EndVpn,
 		pVadList->StartingVpn * PAGE_SIZE, (pVadList->EndVpn + 1) * PAGE_SIZE - 1);
 	
@@ -1026,7 +1024,8 @@ ConsoleCmdVM(
 		pVad = CONTAINING_RECORD(pListEntry, MMVAD, VadListEntry);
 		
 		VpnCount = pVad->EndVpn - pVad->StartingVpn + 1;
-		fprintf(StdHandle, "%d# Vad Include %d Vpn From %d to %d. (0x%X - 0x%X)\n",
+		OutputFormat = "%d# Vad Include %d Vpn From %d to %d. (0x%X - 0x%X)\n";
+		fprintf(StdHandle, OutputFormat,
 			Index, VpnCount, pVad->StartingVpn, pVad->EndVpn,
 			pVad->StartingVpn * PAGE_SIZE, (pVad->EndVpn + 1) * PAGE_SIZE - 1);
 		
@@ -1037,41 +1036,165 @@ ConsoleCmdVM(
 	// ͳҳѷҳδҳ
 	//
 	TotalVpnCount = pVadList->EndVpn - pVadList->StartingVpn + 1;
-	fprintf(StdHandle, "\nTotal Vpn Count: %d.\n", TotalVpnCount);
-	fprintf(StdHandle, "Allocated Vpn Count: %d.\n", AllocatedVpnCount);
+	OutputFormat = "\nTotal Vpn Count: %d.\n";
+	fprintf(StdHandle, OutputFormat, TotalVpnCount);
+	
+	OutputFormat = "Allocated Vpn Count: %d.\n";
+	fprintf(StdHandle, OutputFormat, AllocatedVpnCount);
+	
 	FreeVpnCount = TotalVpnCount - AllocatedVpnCount;
-	fprintf(StdHandle, "Free Vpn Count: %d.\n", FreeVpnCount);
+	OutputFormat = "Free Vpn Count: %d.\n\n";
+	fprintf(StdHandle, OutputFormat, FreeVpnCount);
+	
+	//
+	// ҳҳͿҳ
+	//
+	OutputFormat = "Zeroed Physical Page Count: %d.\n";
+	fprintf(StdHandle, OutputFormat, MiZeroedPageCount);
+	
+	OutputFormat = "Free Physical Page Count: %d.\n\n";
+	fprintf(StdHandle, OutputFormat, MiFreePageCount);
+	
 	
+	//////////////////////////////////////////////////////////////////////////
+	//
+	// һµڴ档ûʹ MEM_COMMIT ־Ϊҳ
+	//
+	PVOID BaseAddress = 0;
+	SIZE_T RegionSize = 1;	
+	Status = MmAllocateVirtualMemory(&BaseAddress, &RegionSize, MEM_RESERVE, TRUE);
+	if (!EOS_SUCCESS(Status)) {
+		fprintf(StdHandle, "Allocate virtual memory at 0x%X faild.\n", BaseAddress);
+		goto VM_RETURN;
+	}
+	
+	//
+	// ·ڴĻַʹС
+	//
+	OutputFormat = "New VM's base address: 0x%X. Size: 0x%X.\n\n";
+	fprintf(StdHandle, OutputFormat, BaseAddress, RegionSize);
+	
+	//
+	//  VAD  VAD ʼҳţҳźͰҳ
+	//
+	Index = AllocatedVpnCount = 0;
+	for(pListEntry = pVadList->VadListHead.Next;
+		pListEntry != &pVadList->VadListHead;
+		pListEntry = pListEntry->Next) {
+	
+		Index++;
+		pVad = CONTAINING_RECORD(pListEntry, MMVAD, VadListEntry);
+		
+		VpnCount = pVad->EndVpn - pVad->StartingVpn + 1;
+		OutputFormat = "%d# Vad Include %d Vpn From %d to %d. (0x%X - 0x%X)\n";
+		fprintf(StdHandle, OutputFormat,
+			Index, VpnCount, pVad->StartingVpn, pVad->EndVpn,
+			pVad->StartingVpn * PAGE_SIZE, (pVad->EndVpn + 1) * PAGE_SIZE - 1);
+		
+		AllocatedVpnCount += VpnCount;
+	}
+	
+	//
+	// ͳѷҳδҳ
+	//
+	OutputFormat = "\nAllocated Vpn Count: %d.\n";
+	fprintf(StdHandle, OutputFormat, AllocatedVpnCount);
+	
+	FreeVpnCount = TotalVpnCount - AllocatedVpnCount;
+	OutputFormat = "Free Vpn Count: %d.\n\n";
+	fprintf(StdHandle, OutputFormat, FreeVpnCount);
+	
+	//
+	// ҳҳͿҳ
+	//
+	OutputFormat = "Zeroed Physical Page Count: %d.\n";
+	fprintf(StdHandle, OutputFormat, MiZeroedPageCount);
+	
+	OutputFormat = "Free Physical Page Count: %d.\n\n";
+	fprintf(StdHandle, OutputFormat, MiFreePageCount);
+	
+	
+	//////////////////////////////////////////////////////////////////////////
+	//
+	// ͷŸոշڴ档
+	//
+	RegionSize = 0;		// ͷڴĴС븳ֵΪ 0
+	MmFreeVirtualMemory(&BaseAddress, &RegionSize, MEM_RELEASE, TRUE);
+	
+	//
+	// ͷŵĵڴĻַʹС
+	//
+	OutputFormat = "Free VM's base address: 0x%X. Size: 0x%X.\n\n";
+	fprintf(StdHandle, OutputFormat, BaseAddress, RegionSize);
+	
+	//
+	//  VAD  VAD ʼҳţҳźͰҳ
+	//
+	Index = AllocatedVpnCount = 0;
+	for(pListEntry = pVadList->VadListHead.Next;
+		pListEntry != &pVadList->VadListHead;
+		pListEntry = pListEntry->Next) {
+	
+		Index++;
+		pVad = CONTAINING_RECORD(pListEntry, MMVAD, VadListEntry);
+		
+		VpnCount = pVad->EndVpn - pVad->StartingVpn + 1;
+		OutputFormat = "%d# Vad Include %d Vpn From %d to %d. (0x%X - 0x%X)\n";
+		fprintf(StdHandle, OutputFormat,
+			Index, VpnCount, pVad->StartingVpn, pVad->EndVpn,
+			pVad->StartingVpn * PAGE_SIZE, (pVad->EndVpn + 1) * PAGE_SIZE - 1);
+		
+		AllocatedVpnCount += VpnCount;
+	}
+	
+	//
+	// ͳѷҳδҳ
+	//
+	OutputFormat = "\nAllocated Vpn Count: %d.\n";
+	fprintf(StdHandle, OutputFormat, AllocatedVpnCount);
+	
+	FreeVpnCount = TotalVpnCount - AllocatedVpnCount;
+	OutputFormat = "Free Vpn Count: %d.\n\n";
+	fprintf(StdHandle, OutputFormat, FreeVpnCount);
+	
+	//
+	// ҳҳͿҳ
+	//
+	OutputFormat = "Zeroed Physical Page Count: %d.\n";
+	fprintf(StdHandle, OutputFormat, MiZeroedPageCount);
+	
+	OutputFormat = "Free Physical Page Count: %d.\n\n";
+	fprintf(StdHandle, OutputFormat, MiFreePageCount);
+	
+VM_RETURN:	
 	KeEnableInterrupts(IntState);	// ж
 	
 	ObDerefObject(pProcCtrlBlock);
 }
 
 
+
 //////////////////////////////////////////////////////////////////////////
 //
 // ǺͿ̨ pm صĴ롣
 //
 
+/*
+ṩʾΪ˲һ߽һԣ
+ȫıʵ˲ӦӦóվʹøʾ롣
+ڳʾԤ;ʹɵżȻ̷ʧ
+ӢʱƼ޹˾еκΡ
+*/
+
+
 PRIVATE
 VOID
 ConsoleCmdPhysicalMemory(
 	IN HANDLE StdHandle
 	)
-/*++
-
-
-	ͳ洢Ϣ̨pm
-
-
-	StdHandle -- ׼롢
-
-ֵ
-	ޡ
-
---*/
 {
 	BOOL IntState;
+	ULONG_PTR PfnArray[4];
 
 	IntState = KeEnableInterrupts(FALSE);	// ж
 	
@@ -1094,10 +1217,34 @@ ConsoleCmdPhysicalMemory(
 	//
 	fprintf(StdHandle, "\nUsed Page Count: %d.\n", MiTotalPageFrameCount - MiZeroedPageCount - MiFreePageCount);
 	
+	
+	//////////////////////////////////////////////////////////////////////////
+	// һҳ
+	//
+	MiAllocateAnyPages(4, PfnArray);
+	
+	fprintf(StdHandle, "\n****** After Allocate One Page ******\n");
+	fprintf(StdHandle, "Zeroed Page Count: %d.\n", MiZeroedPageCount);
+	fprintf(StdHandle, "Free Page Count: %d.\n", MiFreePageCount);
+	fprintf(StdHandle, "Used Page Count: %d.\n", MiTotalPageFrameCount - MiZeroedPageCount - MiFreePageCount);
+	
+	
+	//////////////////////////////////////////////////////////////////////////
+	//
+	// Ȼͷҳ
+	//
+	MiFreePages(4, PfnArray);
+	
+	fprintf(StdHandle, "\n****** After Free One Page ******\n");
+	fprintf(StdHandle, "Zeroed Page Count: %d.\n", MiZeroedPageCount);
+	fprintf(StdHandle, "Free Page Count: %d.\n", MiFreePageCount);
+	fprintf(StdHandle, "Used Page Count: %d.\n", MiTotalPageFrameCount - MiZeroedPageCount - MiFreePageCount);
+	
 	KeEnableInterrupts(IntState);	// ж
 }
 
 
+
 //////////////////////////////////////////////////////////////////////////
 //
 // ǺͿ̨ pt صĴ롣
-- 
2.34.1.windows.1


From 4d88b016b47e5f799018315560addc74daf43a57 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?=E5=A7=9C=E6=B5=B7=E5=A4=A9?= <1076168468@qq.com>
Date: Sat, 29 Oct 2022 16:48:13 +0800
Subject: [PATCH 2/2] =?UTF-8?q?=E5=A4=84=E7=90=86MiAllocateAnyPages?=
 =?UTF-8?q?=E5=87=BD=E6=95=B0=E6=97=A0=E6=B3=95=E5=88=86=E9=85=8D=E5=86=85?=
 =?UTF-8?q?=E5=AD=98=E6=83=85=E5=86=B5?=
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

---
 pfnlist.c | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

diff --git a/pfnlist.c b/pfnlist.c
index 3a4ad74..19bf349 100644
--- a/pfnlist.c
+++ b/pfnlist.c
@@ -135,6 +135,7 @@ MiAllocateAnyPages(
 	BOOL IntState;
 	ULONG_PTR Pfn;
 	ULONG_PTR i;
+	STATUS status;
 
 	IntState = KeEnableInterrupts(FALSE);
 
@@ -167,11 +168,16 @@ MiAllocateAnyPages(
 
 			PfnArray[i] = Pfn;
 		}
+		
+		status = STATUS_SUCCESS;
+		
+	}else{
+		status = STATUS_NO_MEMORY;
 	}
 
 	KeEnableInterrupts(IntState);
 
-	return STATUS_SUCCESS;
+	return status;
 }
 
 STATUS
-- 
2.34.1.windows.1

